<?php
include 'config.php';

// check if user is already logged in
if (is_logged() === true) {
	die("You are already logged in.");
}

if (isset($_POST["submit"]))
{
	if (isset($_POST["username_or_email"]) && isset($_POST["password"])) {

		$username = $_POST["username_or_email"];
		$email = $_POST["username_or_email"];
		$password = $_POST["password"];

		$stmt = mysqli_prepare($conn, "SELECT Usernames, Passwords, Emails, Account_Activation_Codes, Account_Activations FROM users WHERE Usernames = ? OR Emails = ?");
		mysqli_stmt_bind_param($stmt, 'ss', $username, $email);
		mysqli_stmt_execute($stmt);
		$result = mysqli_stmt_get_result($stmt);

        $row = mysqli_fetch_array($result, MYSQLI_ASSOC);
		
		// check for username and password matching
        if ($username == $row['Usernames']  || $email == $row['Emails'] && password_verify($password, $row['Passwords'])) {

        	/* 
        	* check if user have activation link in database, if it have so he is not activated hes account
        	* or
			* check if user Activation_Accounts is set to 1 its active and 0 is not active
			*/
        	if ($row['Account_Activation_Codes'] != '' || $row['Account_Activations'] == '0') {
        		$error = "You didn't activated your account. Please check your email.";
        	} else {		

	        	// if remember me check box is checked set cookie
	        	if (isset($_POST['remember']) && $_POST['remember'] == "on") {
	        		/*
					* if you want to set cookie, set only hash and store it into database
					* when you come on login page you need to check  if that hash from cookie exists in database
					* if it exist just start session
					* NEVER STORE USERNAMES, EMAILS, PASSWORDS AND OTHER USER INFORMATION IN COOKIE
					* this i will leave to you so you can play with :)
	        		*/

	        		//setcookie("username_or_email", $username_or_email, time()+ (10 * 365 * 24 * 60 * 60));
					//setcookie("password", $password, time()+ (10 * 365 * 24 * 60 * 60));
	        	} else {
	        		// start session
	        		$_SESSION["user"] = $username;
	        		$_SESSION["user"] = $email;

	        		// redirect to member page
	        		header("Location: home.php");
	        		exit();
	        	}

	        }
					
	    } else {
            $error = "Invalid username or password.";
        }		
	}
}	

?>
<!DOCTYPE html>
<html>
	<head>
		<title><?php $site_name?> Member Login Page</title>
	</head>
<body>
<div class="container">
	<form method="post" action="">
	<h3 style="text-align:center;"><?php $site_name ?> Member Login Form</h3>

	<?php if(!empty($error)) { echo '<p style="color:red; text-align:center;">'.$error.'</p>'; } ?>

		<div class="form-group">
			<center><label>Username/Email:</label>
			<input type="text" placeholder="Enter Username or Email" name="username_or_email" required></center>
		</div>
		<div class="form-group">
			<center><label>Password:</label>
			<input type="password" placeholder="Enter password" name="password" required></center>
		</div>
		<div class="form-group">
			<center><label>Remember Login Details:</label>
			<input type="checkbox" name="remember"></center>
		</div>
		<div class="form-group">
			<center><input type="submit" name="submit" value="Login" class="button button-success"></center>
		</div>

		<div class="form-group">
			<center><font color="red" size="3"><b>Forgot your password ?</b><br><a href="member_login_password_reset.php">Reset it here!</a></font></center>
			<center><font color="red" size="3"><b>Not registered ?</b><br><a href="register.php">Register here!</a></font></center>
		</div>
	</form>
</div>
</body>
</html>