<?php
include 'config.php';

// check if user is already logged in
if (is_logged() === true) {
	die("You are logged in, can't register.");
}

if  (isset($_POST['submit']))
{
	if (isset($_POST["username"]) && 
	   isset($_POST["password"]) &&
	   isset($_POST["password_confirmation"]) && 
	   isset($_POST["email"]) && 
	   isset($_POST["email_confirmation"]) && 
	   isset($_POST["forename"]) && 
	   isset($_POST["gender"]) &&
	   isset($_POST["surname"])) {

		// create random hash for email confirmation
	   	$member_registration_random_numbers = sha1(mt_rand(5, 30));

	   	// did't tested this if send activation, because im on localhost
		$account_activation_link = "http://www.'".$site_domain."'.com/$site-name/activate_account.php?email='".$_POST['email']."'&hash='".$member_registration_random_numbers."'";

   		// remove space in start of string
   		/*
		*	passwords and email are leaved unescaped here because
		*	if you put them into mysqli_real_escape_string they are not empty
   		*/
        $username 	= trim(mysqli_real_escape_string($conn, $_POST["username"]));
		$password 	= $_POST["password"];
		$password2 	= $_POST["password_confirmation"];
        $forename 	= trim(mysqli_real_escape_string($conn, $_POST["forename"]));
        $surname 	= trim(mysqli_real_escape_string($conn, $_POST["surname"]));
		$gender 	= trim(mysqli_real_escape_string($conn, $_POST["gender"]));
        $email 		= $_POST["email"];
        $email_confirmation = $_POST["email_confirmation"];
        $email2 	= trim(mysqli_real_escape_string($conn, $email)); // escaped email for inserting into database
        $activation = 1; // 1 = active | 0 = not active

        // hashed password
        $hashed_pass = password_hash($password, PASSWORD_DEFAULT); 
	
        // select username and email to check if they exists.
		$stmt = mysqli_prepare($conn, "SELECT Usernames, Emails FROM users WHERE Usernames = ? OR Emails = ?");
		mysqli_stmt_bind_param($stmt, 'ss', $username, $email);
		mysqli_stmt_execute($stmt);
		$result = mysqli_stmt_get_result($stmt);

        $row = mysqli_fetch_array($result, MYSQLI_ASSOC);

		// check if username is registered
		if ($row['Usernames'] == $username) {
			$_SESSION['error'] = "That username is already registered.";
		// check if username is between 6 and 30 characters long
		} elseif (strlen($username) < 6 || strlen($username) > 30) {
			$_SESSION['error'] = "Username must be between 6 and 30 characters long.";
		// check if email is registered
		} elseif ($row['Emails'] == $email) {
			$_SESSION['error'] = "That email is already registered.";
		// check if emails match
		} elseif ($email != $email_confirmation) {
			$_SESSION['error'] = "Emails don't match.";
		// check if email is actual email
		} elseif (!filter_var($email, FILTER_VALIDATE_EMAIL)) {
			$_SESSION['error'] = "Invalid email format.";
		// check if passwords match
		} elseif ($password != $password2) {
			$_SESSION['error'] = "Passwords don't match.";
		// check if password lenght is between 6 and 30 charaters long
		} elseif (strlen($password) < 6 || strlen($password) > 30) {
			$_SESSION['error'] = "Password must be between 6 and 30 characters long.";
		} else {

			// insert query
			$stmt = mysqli_prepare($conn, "INSERT INTO users(Usernames, Passwords, Emails, Forenames, Surnames, Genders, Account_Activation_Codes, Account_Activations) VALUES (?, ?, ?, ?, ?, ?, ?, ?)");
			mysqli_stmt_bind_param($stmt, 'sssssssi', $username, $hashed_pass, $email2, $forename, $surname, $gender, $member_registration_random_numbers, $activation);
			mysqli_stmt_execute($stmt);

			// check if query is inserted
			if (mysqli_stmt_insert_id($stmt)) {
				echo "<h3 style='text-align:center'>Thank you for your registration.<br /> Redirecting to login page ...</h3>";

				// redirect to login page after 5 seconds
				header("refresh:5;url=login.php");

				// empty $_SESSION['error'] variable so no more in use, its empty now
				unset($_SESSION['error']);
				unset($_POST);
				exit(); 

				// check if email is sent
				/** I COMMENTED THIS BECAUSE IM WORKING ON LOCALHOST AND CANT SEND EMAILS
				$to = $email;
			    $subject = "Your '".$site_name."' Account Activation!";
			    $body = $forename.' '.$surname."\n\n You need to click the following link to confirm your email address and activate your account.\n\n\
			    $account_activation_link";
				$from = $site_admin_email;
			    $headers = "from: " . $from;
			
			    if (mail($to,$subject,$body,$headers)) {
			    	$_SESSION['error'] = "Registration sucessfuly. Check your email for further instructions!";
			    } else {
			    	$_SESSION['error'] = "Email not sent, please contact website administrator.";
			    }
			    */
			} else {
				$_SESSION['error'] = "There was a problem with registering, please try again.";
			}

	    }
	}
}


?>
<!DOCTYPE html>
<html>
	<head>
		<title><?php $site_name ?> Signup Page</title>
	</head>
<body>
<div class ="container">

<?php

// error messages
if (isset($_SESSION['error']) && !empty($_SESSION['error'])) {
	echo '<p style="color:red;">'.$_SESSION['error'].'</p>';
}

?>

<form method="post" action="">
	<center><h2>Signup Form</h2></center>
	<div class="form-group">
		<center><label>Username:</label>
		<input type="text" placeholder="Enter a unique Username" name="username" required [A-Za-z0-9] value="<?php if(isset($_POST['username'])) { echo htmlentities($_POST['username']); }?>"></center>
	</div>
	<div class="form-group">
		<center><label>Password:</label>
		<input type="password" placeholder="Enter a new Password" name="password" required [A-Za-z0-9]></center>
	</div>
	<div class="form-group">
		<center><label>Repeat Password:</label>
		<input type="password" placeholder="Repeat a new Password" name="password_confirmation" required [A-Za-z0-9]></center>
	</div>
	<div class="form-group">
		<center><label>First Name:</label>
		<input type="text" placeholder="Enter your First Name" name="forename" required [A-Za-z] value="<?php if(isset($_POST['forename'])) { echo htmlentities($_POST['forename']); }?>"></center>
	</div>
	<div class="form-group">
		<center><label>Surname:</label>
		<input type="text" placeholder="Enter your Surname" name="surname" required [A-Za-z] value="<?php if(isset($_POST['surname'])) { echo htmlentities($_POST['surname']); }?>"></center>
	</div>
	<div class="form-group">
		<center><label>Gender:</label>
		<input type="radio" name="gender" value="male" <?php if(isset($_POST['gender'])) { echo 'checked'; }?> required>Male<input type="radio" name="gender" value="female" <?php if(isset($_POST['gender'])) { echo 'checked'; }?> required>Female</center>
	</div>
	<div class="form-group">
		<center><label>Email:</label>
		<input type="email" placeholder="Enter your Email" name="email" required [A-Za-z0-9] value="<?php if(isset($_POST['email'])) { echo htmlentities($_POST['email']); }?>"></center>
	</div>
	<div class="form-group">
		<center><label>Repeat Email:</label>
		<input type="email" placeholder="Repeat your Email" name="email_confirmation" required [A-Za-z0-9] value="<?php if(isset($_POST['email_confirmation'])) { echo htmlentities($_POST['email_confirmation']); }?>"></center>
	</div>
	<center><button type="submit" class="btn btn-default" name="submit">Register!</button></center>
	<center><font color="red" size="3"><b>Already have an account ?</b><br><a href="login.php">Login here!</a></font></center>

</form>

</div>
</body>
</html>